#pragma semicolon 1

#include <sourcemod>
#include <sdktools>

#define ALPHA_SET 0.5
#define DURATION_SET 0.0

new bool:bActiveBlock[MAXPLAYERS + 1];
new bool:bBuyActive[MAXPLAYERS + 1];
new g_iAmount;
new Handle:hAntiFlashPrice;

new g_iFlashAlpha = -1;
new g_iFlashDuration = -1;

public Plugin:myinfo =
{
	name = "Buy_AntiFlash",
	description = "",
	author = "@Samil#",
	version = "1.0",
	url = "sourcemod-plugins.ru"
};

public OnPluginStart()
{
	RegConsoleCmd("sm_buy_antiflash", Create_Menu);
	HookEvent("flashbang_detonate", OnFlashDetonate);
	HookEvent("round_end", OnRoundEnd);
	HookEvent("player_death", OnPlayerDeath);
	hAntiFlashPrice = CreateConVar("sm_price_item", "5000", "Стоимость антифлеша в игровой волюте <$>");
}

public OnClientPostAdminCheck(client)
{
	if (bBuyActive[client]) bBuyActive[client] = false;
	if (bActiveBlock[client]) bActiveBlock[client] = false;
}

public Action:Create_Menu(client, args)
{
	if (IsPlayerAlive(client))
	{
		new iAntiFlashPrice = GetConVarInt(hAntiFlashPrice);
		g_iAmount = GetEntProp(client, Prop_Send, "m_iAccount");
		if (g_iAmount >= iAntiFlashPrice)
		{
			if (!bBuyActive[client])
			{
				SetEntProp(client, Prop_Send, "m_iAccount", g_iAmount - iAntiFlashPrice);
			}
			bBuyActive[client] = true;
			MenuChoise(client);
		}
		else
		{
			PrintToChat(client, "У вас не хватает денег");
			PrintToChat(client, "Цена антифлеша %d", iAntiFlashPrice);
		}
	}
	else
	{
		PrintToChat(client, "Чтобы купить антифлеш, нужно быть живым");
	}
	return Plugin_Handled; 
}

MenuChoise(client)
{
	new Handle:menu = CreateMenu(Select_ChoiseMenu);
	SetMenuTitle(menu, "Выберите действие:");
	AddMenuItem(menu, "", "Включить защиту");
	AddMenuItem(menu, "", "Выключить защиту");
	AddMenuItem(menu, "", "Выкинуть защиту");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 0);
}

public Select_ChoiseMenu(Handle:menu, MenuAction:action, client, option) 
{
	if (action == MenuAction_End)
	{  
		CloseHandle(menu); 
		return;
	}
	if (action == MenuAction_Select)
	{
		switch(option)
		{
			case 0:
			{
				Activity(client);
				bActiveBlock[client] = true;
			}
			case 1:
			{
				DisActivity(client);
				bActiveBlock[client] = false;
				ActiveFlash(client);
			}
			case 2:
			{
				DisActivity(client);
				bBuyActive[client] = false;
				bActiveBlock[client] = false;
				ActiveFlash(client);
			}
		}
	}
}

public OnRoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new x = 1; x <= MaxClients; x++)
	{
		DisActivity(x);
		if (bBuyActive[x]) bBuyActive[x] = false;
		if (bActiveBlock[x]) bActiveBlock[x] = false;
	}
}

public OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event,"userid"));
	DisActivity(client);
	if (bBuyActive[client]) bBuyActive[client] = false;
	if (bActiveBlock[client]) bActiveBlock[client] = false;
}

public OnPlayerBlind(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event,"userid"));
	if (bActiveBlock[client] && IsClientObserver(client))
	{
		StopFlash(client);
	}
}

public OnFlashDetonate(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event,"userid"));
	decl Float:DetonateOrigin[3], Float:EyePosition[3];
	DetonateOrigin[0] = GetEventFloat(event, "x"); 
	DetonateOrigin[1] = GetEventFloat(event, "y"); 
	DetonateOrigin[2] = GetEventFloat(event, "z");
	GetClientEyePosition(client, EyePosition);
	if (GetVectorDistance(DetonateOrigin, EyePosition) <= 1500.0)
	{
		EyePosition[2] -= 0.5;
		new Handle:trace = TR_TraceRayFilterEx(DetonateOrigin, EyePosition, CONTENTS_SOLID, RayType_EndPoint, FilterTarget, client);
		if ((TR_DidHit(trace) && TR_GetEntityIndex(trace) == client) || (GetVectorDistance(DetonateOrigin, EyePosition) <= 100.0))
		{
			if (bActiveBlock[client]) StopFlash(client);
			CloseHandle(trace);
		}
	}
}

Activity(client)
{
	new Handle:h_msg = StartMessageOne("Fade", client); 
	if (h_msg != INVALID_HANDLE) 
	{ 
		BfWriteShort(h_msg, 0x0001); 
		BfWriteByte(h_msg, 128); 
		BfWriteByte(h_msg, 128); 
		BfWriteByte(h_msg, 128); 
		BfWriteByte(h_msg, 85); 
		EndMessage(); 
	}
}

DisActivity(client)
{
	new Handle:h_msg = StartMessageOne("Fade", client); 
	if (h_msg != INVALID_HANDLE) 
	{ 
		BfWriteShort(h_msg, 0x0001); 
		BfWriteByte(h_msg, 255); 
		BfWriteByte(h_msg, 255); 
		BfWriteByte(h_msg, 255); 
		BfWriteByte(h_msg, 0); 
		EndMessage(); 
	}
}

public bool:FilterTarget(entity, contentsMask, any:data)
{
	return (data == entity);
} 

StopFlash(client)
{
	SetEntDataFloat(client, g_iFlashAlpha, ALPHA_SET);
	SetEntDataFloat(client, g_iFlashDuration, DURATION_SET);
	ClientCommand(client, "dsp_player 0.0");
}

ActiveFlash(client)
{
	ClientCommand(client, "dsp_player 1.0");
}
